#ifndef GRID
#define GRID
#include "Vector2.h"

class Grid
{
private:
   int size;
   Vector2 ** points;
   std::vector<Vector2> polygon;
   std::vector<Vector2> movedPolygon;

public:
   static const int DRAW_WIRE = 0;
   static const int DRAW_TEXTURE = 1;
   int drawStyle;

   Grid();
   void Resize(int n);

   void Draw();
   void AddPolygonPoint(const float & x, const float & y);
   void MovePolygonPoint(const float & x, const float & y, const float & dx, const float & dy);
   void ClearPlygon() { polygon.clear(); movedPolygon.clear(); }
   void ResetPolygon() { for (unsigned int i = 0; i < polygon.size(); ++i) movedPolygon[i] = polygon[i]; }
   ~Grid(void);
};

#endif
