// new test program to check matrix inversion template code
//#include <stdio.h>
//#include <stdlib.h>
#include <iostream>
#include <complex>
#include "matrix.h"

typedef complex<double> C;

void dumpMatrixValues(matrix <C> M)  {
  bool xyz;
  C rv;
  for (int i=0; i < M.getactualsize(); i++) {
    cout << "i=" << i << ": ";
    for (int j=0; j < M.getactualsize(); j++) {
      M.getvalue(i,j,rv,xyz);
      cout << rv << " ";
    }
    cout << endl;
  }
};

int main (int argc, char** argv)  {
  cout << "hello world; this is a test of matrix inversion." << endl;
  matrix <C> M1(2,2), M2(2,2), M3(2,2);

  for (int i = 0; i < M1.getactualsize(); i++)  // define random values for initial matrix
    for (int j = 0; j < M1.getactualsize(); j++)
      M1.setvalue(i,j, C(i+1, j+1));

  cout << "original matrix (size " << M1.getactualsize() << " x "
       << M1.getactualsize() << ") created and filled with random values."<< endl;
  dumpMatrixValues(M1);
  
  M2.copymatrix(M1);

  M1.invert();  // invert the matrix -- note that this is a mutator
  cout << "DONE with matrix inversion!" << endl;
  dumpMatrixValues(M1);

  M3.settoproduct(M1,M2);
  cout << "product computed; original x inverse:" << endl;
  dumpMatrixValues(M3);

  M3.settoproduct(M2,M1);
  cout << "product computed; inverse x original:" << endl;
  dumpMatrixValues(M3);
}
